#!/usr/bin/env python

from re import compile as recompile
from sss.ssslib import comm_lib
from string import join, split
from sys import argv, exit
from elementtree.ElementTree import Element, SubElement, XML, tostring

def usage():
    print """Usage:
nsmclient.py get -r restrictions 
 or
nsmclient.py set key=value -r restrictions
 or
nsmclient.py del -r restrictions
 or
nsmclient.py add values
nsmclient.py diag key=value -r restrictions"""
    exit(1)

getargre = recompile("^(-d ){0,1}get -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
setargre = recompile("^(-d ){0,1}set (?P<update>\S+=\S+) -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
addargre = recompile("^(-d ){0,1}add (?P<values>(\S+=\S+ {0,1})+)$")
delargre = recompile("^(-d ){0,1}del -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
diagargre = recompile("^(-d ){0,1}diag (?P<values>(\S+=\S+ {0,1})+) -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
argstring = join(argv[1:]," ")

if getargre.match(argstring):
    restrictions = getargre.match(argstring).group("restrictions")
    req = Element("get-node-state")
    ns = SubElement(req, "node-state")
    for el in ['node','state','adminstate']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = "false"
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    action = "get"
elif setargre.match(argstring):
    restrictions = setargre.match(argstring).group("restrictions")
    update = setargre.match(argstring).group("update")
    req = Element("set-node-state")
    ns = SubElement(req, "node-state")
    for el in ['node','state','adminstate']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = "false"
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    SubElement(req, split(update,"=")[0])
    req.find(split(update,"=")[0]).text = split(update,"=")[1]
    action = "set"
elif addargre.match(argstring):
    values = addargre.match(argstring).group("values")
    req = Element("add-node-state")
    ns = SubElement(req, "node-state")
    for value in split(values):
        if ns.find(split(value,"=")[0]) == None:
            SubElement(ns, split(value,"=")[0])
        ns.find(split(value,"=")[0]).text = split(value,"=")[1]
    action = "add"
elif delargre.match(argstring):
    restrictions = delargre.match(argstring).group("restrictions")
    req = Element("del-node-state")
    ns = SubElement(req, "node-state")
    for el in ['node','state','adminstate']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = "false"
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    action = "del"
elif diagargre.match(argstring):
    restrictions = diagargre.match(argstring).group("restrictions")
    values = diagargre.match(argstring).group("values")
    req = Element("diagnose")
    for value in split(values):
        if req.find(split(value,"=")[0]) == None:
            SubElement(req, split(value,"=")[0])
        req.find(split(value,"=")[0]).text = split(value,"=")[1]
    ns = SubElement(req, "node-state")
    for el in ['node','state','adminstate']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = "false"
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    action = "diag"
else:
    usage()
    
sss = comm_lib(debug=('-d' in argv))
handle = sss.ClientInit("node-state-manager")
sss.SendMessage(handle,tostring(req))
msg = sss.RecvMessage(handle)
sss.ClientClose(handle)
del sss
try:
    domobj = XML(msg)
except:
    print "server error"
    exit(1)

if domobj.findall("node-state") != []:
    fields = [el.tag for el in domobj.find("node-state")]
    results=[tuple(fields)]
    for record in domobj.findall("node-state"):
        results.append(tuple(map(lambda x:record.find(x).text, fields)))
    lendata=map(lambda x:map(len,x),results)
    fsizes=tuple(map(lambda i:apply(max,map(lambda x:x[i],lendata)),range(len(lendata[0]))))
    fstring=join(['%%%ss']*len(fsizes),'   ')%(fsizes)
    i=0
    for data in results:
        print fstring%data
        if not i:
            print "================================================================================"
            i=1
    

